/*********************************************************************
*                                                                    *          
*                              FLY                                   *
*                           --E#Y#E--				     *
*                         ===MUSCLE===                               *
*                                                                    *
*********************************************************************/
#ifndef UNIFORM_H_
#define UNIFORM_H_

/* C++ Header Files */
#include <map>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <fstream>
#include <iostream>
#include <vector>
#include <cmath>
/* OpenGL */
#include <GL/glew.h>
#include <GL/gl.h>
#include <GL/glx.h>
#include <GL/glu.h>
/* Flysimulator */
#include "cockpit.h"
#include "opengl.h"

using namespace std;

//---------------------------------------------------------------------------
		
/* Class Uniform */
class UNIFORM
{
private:
	char *vert;
	char *frag;
	const GLchar* tmp;
	fstream vertShader;
	fstream fragShader;
	GLuint location;

	struct fragment
	{
		char *log;
		unsigned int id;
        	GLuint filename;
        	GLuint source;
		GLint result;
		GLint info;
		
	}fragmentShader;

	struct vertex
	{
		char *log;
		unsigned int id;
        	GLuint filename;
	        GLuint source;
	        GLint result;
		GLint info;
		
	}vertexShader;

public:	
	/* Function */
	void CreateShader();
	void CreateProgram(GLuint shaderProgram);	
	void Location(GLuint shaderProgram, unsigned int index, const char* name);
	void Uniform(GLuint shaderProgram, const char* name, const float matrix);
	void Uniform4x4(GLuint shaderProgram, const char* name, const float* matrix, char transpose);
	void DeleteShader(GLuint shaderProgram);	

};

//---------------------------------------------------------------------------

#endif
